unit Main;

interface

uses
  Forms, SysUtils, Base, Classes, Controls, StdCtrls;

type
  TMainForm = class(TBaseForm)
    ListBox1: TListBox;
  private
    { Private 錾 }
    procedure	ShowMsg(AMsg: string);
  public
    { Public 錾 }
	procedure	DroppedAction(); override;
  end;

var
  MainForm: TMainForm;

implementation

uses
	ComObj;

{$R *.dfm}

(*
	#############################################
    ###                                       ###
    ###   motivated by                        ###
    ###                                       ###
	###   http://i16.jp/soft/excel2text.htm   ###
    ###                                       ###
	#############################################
*)

(* WORD to TEXT *)
function	Word2Text(ADocPath: string): string;
var
	MsWord: Variant;
begin
    if (FileExists(ADocPath)) and
       (UpperCase(ExtractFileExt(ADocPath)) = '.DOC') then
    begin
        MsWord := CreateOleObject('Word.Application.9');
        try try
            MsWord.Documents.Open(ADocPath);
            MsWord.Visible := False;
            MsWord.ActiveDocument.SaveAs(ADocPath + '.txt', 2);
            MsWord.ActiveDocument.Close();
            Result := '';
        except
			on E:Exception do
            begin
            	Result := E.Message;
            end;
        end;
        finally
            MsWord.Quit;
        end;
    end else
    begin
		Result := 'gqႤC܂B';
    end;
end;

(* EXCEL to TEXT *)
function	Excel2Text(ADocPath: string): string;
var
	MsExcel: Variant;
    i: integer;
begin
    if (FileExists(ADocPath)) and
       (UpperCase(ExtractFileExt(ADocPath)) = '.XLS') then
    begin
        MsExcel := CreateOleObject('Excel.Application');
        try try
            MsExcel.Workbooks.Open(ADocPath);
            MsExcel.Visible := False;
            for i := 1 to MsExcel.ActiveWorkbook.WorkSheets.Count do
            begin
                MsExcel.ActiveWorkbook.WorkSheets[i].SaveAs(ADocPath + IntToStr(i) + '.txt', 6);
			end;
            MsExcel.ActiveWorkbook.Close();
            Result := '';
        except
			on E:Exception do
            begin
            	Result := E.Message;
            end;
        end;
        finally
            MsExcel.Quit;
        end;
    end else
    begin
		Result := 'gqႤC܂B';
    end;
end;

(* ShowMsg *)
procedure	TMainForm.ShowMsg(AMsg: string);
begin
	ListBox1.Items.Add(AMsg);
    ListBox1.ItemIndex := ListBox1.Items.Count - 1;
    ListBox1.Repaint;
end;

(* DroppedAction *)
procedure	TMainForm.DroppedAction();
var
	i: integer;
    Msg: string;
    Ext: string;
begin
    for i := 0 to DropFileList.Count - 1 do
    begin
        Ext := UpperCase(ExtractFileExt(DropFileList[i]));
        if Ext = '.DOC' then
        begin
	        Msg := Word2Text(DropFileList[i]);
        end else
        if Ext = '.XLS' then
        begin
	        Msg := Excel2Text(DropFileList[i]);
        end else
        begin
			Msg := 'gqΉłB >> ' + Ext;
        end;
		if Msg = ''then
        begin
        	Msg := 'ł܂B';
        end;
		ShowMsg(Msg + ' >> ' + DropFileList[i]);
    end;
end;

end.
